//
//  ViewController.swift
//  WalletDemo
//
//  Created by TBS17 on 27/11/18.
//  Copyright © 2018 Techcronus Bussiness Solutions. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    var mnemonic:String!
    var seed:Data!
    var TBTCWallet:Wallet!
    var MBTCWallet:Wallet!
    var TETHWallet:Wallet!
    var METHWallet:Wallet!
    var TLTCWallet:Wallet!
    var MLTCWallet:Wallet!
    var TBCHWallet:Wallet!
    var MBCHWallet:Wallet!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        
//        let entropy = Data(hex: "000102030405060708090a0b0c0d0e0f")
//        mnemonic = Mnemonic.create(entropy: entropy)
        mnemonic = "fly weasel genuine enact humor catch prison upper spatial sure mechanic excess hint lazy uphold need violin sport also certain cannon spread include float"
        seed = Mnemonic.createSeed(mnemonic: mnemonic)
        
//        TBTCWallet = Wallet(seed: seed, network: .test(.bitcoin))
//        MBTCWallet = Wallet(seed: seed, network: .main(.bitcoin))
//        TETHWallet = Wallet(seed: seed, network: .test(.ethereum))
//        METHWallet = Wallet(seed: seed, network: .main(.ethereum))
//        TLTCWallet = Wallet(seed: seed, network: .test(.litecoin))
//        MLTCWallet = Wallet(seed: seed, network: .main(.litecoin))
//        TBCHWallet = Wallet(seed: seed, network: .test(.bitcoinCash))
//        MBCHWallet = Wallet(seed: seed, network: .main(.bitcoinCash))
        
        testMainnetChildKeyDerivation()
        
//        testBitcoinMainNetAddressGeneration()
//        testEthereumAddressGeneration()
//        testLitecoinAddressGeneration()
//        mainLitecoinAddressGeneration()
//        testBitcoinCashAddressGeneration()
//        mainBitcoinCashAddressGeneration()
    }

    func testMainnetChildKeyDerivation() {
        let privateKey = PrivateKey(seed: seed, coin: .litecoin)
        
        // BIP44 key derivation
        // m/44'
        let purpose = privateKey.derived(at: .hardened(44))
        
        // m/44'/2'
        let coinType = purpose.derived(at: .hardened(2))
        
        // m/44'/0'/0'
        let account = coinType.derived(at: .hardened(0))
        
        // m/44'/0'/0'/0
        let change = account.derived(at: .notHardened(0))
        
        // m/44'/0'/0'/0/0
        
        for i in 0..<3 {
            let firstPrivateKey = change.derived(at: .notHardened(UInt32(i)))
            print("Mainnet ChildKey_",i,": ",firstPrivateKey.publicKey.address)
            print("Mainnet PrivateKey_",i,": ",firstPrivateKey.get())
            print("Mainnet PublicKey_",i,": ",firstPrivateKey.publicKey.get())
        }
    }
    
    func testEthereumAddressGeneration() {
        let wallet = Wallet(seed: seed, coin: .ethereum)
        
        let firstAccount = wallet.generateAccount(at: 0)
        print("ETH Address: ", firstAccount.address)
        print("ETH Public Key: ", firstAccount.rawPublicKey)
        print("ETH Private Key: ", firstAccount.rawPrivateKey)
        
        for i in 0..<10 {
            let address = METHWallet.generateAddress(at: UInt32(i))
            print("ETH Address%d: %@",i, address)
        }
    }
    
    
   /* func testBitcoinMainNetAddressGeneration() {
        for i in 0..<10 {
            let address = TBTCWallet.generateAddress(at: UInt32(i))
            print("BTC Address%d: %@",i, address)
        }
        
//        XCTAssertEqual(firstAccount.address, "128BCBZndgrPXzEgF4QbVR3jnQGwzRtEz5")
//        XCTAssertEqual(firstAccount.rawPublicKey, "03ce9b978595558053580d557ff40f9f99a4f1a7609c25268863ee64de7e4abbda")
//        XCTAssertEqual(firstAccount.rawPrivateKey, "L35qaFLpbCc9yCzeTuWJg4qWnTs9BaLr5CDYcnJ5UnGmgLo8JBgk")
        
    }
    
    
    
    
    func testLitecoinAddressGeneration() {
//        let wallet = Wallet(seed: seed, network: .test(.litecoin))
//
//        let firstAccount = wallet.generateAccount(at: 0)
//
//        print("TLTC Address: ", firstAccount.address)
//        print("TLTC Public Key: ", firstAccount.rawPublicKey)
//        print("TLTC Private Key: ", firstAccount.rawPrivateKey)
        
        for i in 0..<10 {
            let address = MLTCWallet.generateAddress(at: UInt32(i))
            print("LTC Address%d: %@",i, address)
        }
        
//        XCTAssertEqual(firstAccount.address, "LV8fThzQw45HT6bCgs1yfvLNzv4aFvjJt1")
//        XCTAssertEqual(firstAccount.rawPublicKey, "026eeb12b93ab20b32970e2fa0e7fbaa97f9016dc743ad3efc922681ce33adc40d")
//        XCTAssertEqual(firstAccount.rawPrivateKey, "T3d12aqL7XSNqMojMtqBZGhQ6E93dzrdbnNUKMvdmVTa9TQn4L3m")
//
//        let secondAddress = wallet.generateAddress(at: 1)
//        XCTAssertEqual(secondAddress, "Lg7bkp36nPJdqoYAfpmR1UUdXgSq9iCxBX")
//
//        let thirdAddress = wallet.generateAddress(at: 2)
//        XCTAssertEqual(thirdAddress, "LRajgVNRke9ttvrnncpH52iNAbCFdSxq2b")
//
//        let forthAddress = wallet.generateAddress(at: 3)
//        XCTAssertEqual(forthAddress, "LcZoNSHLQc1XGjMLy6PdqE8PtphMbRPCQ3")
    }
    
    func mainLitecoinAddressGeneration() {
        let wallet = Wallet(seed: seed, network: .main(.litecoin))
        
        let firstAccount = wallet.generateAccount(at: 0)
        
        print("MLTC Address: ", firstAccount.address)
        print("MLTC Public Key: ", firstAccount.rawPublicKey)
        print("MLTC Private Key: ", firstAccount.rawPrivateKey)
    }
    
    func testBitcoinCashAddressGeneration() {
        let wallet = Wallet(seed: seed, network: .test(.bitcoinCash))
        
        let firstAccount = wallet.generateAccount(at: 0)
        
        print("TBCH Address: ", firstAccount.address)
        print("TBCH Public Key: ", firstAccount.rawPublicKey)
        print("TBCH Private Key: ", firstAccount.rawPrivateKey)
//        XCTAssertEqual(firstAccount.address, "1FYh9oXWbAzgcX3hPSrRWUodYWt87bMmne")
//        XCTAssertEqual(firstAccount.rawPublicKey, "030f6c58f37ffe1bf56dd79fac07f339f44d96efaa3d78e1f32fadd41dcd0b7bbc")
//        XCTAssertEqual(firstAccount.rawPrivateKey, "KwgDcj2ZDN5vzRXsTv1F6vzQV7nx7shEYjFBcWng1sH6Fy9rhK2b")
        
//        let secondAddress = wallet.generateAddress(at: 1)
//        XCTAssertEqual(secondAddress, "19Q2M5swtorWmL9ZdhtaxBFFuhUuBr9z1Q")
//
//        let thirdAddress = wallet.generateAddress(at: 2)
//        XCTAssertEqual(thirdAddress, "1QDAX8eZXMjVdZxMzHyXr81uWu9ZDWd9vR")
//
//        let forthAddress = wallet.generateAddress(at: 3)
//        XCTAssertEqual(forthAddress, "1Jgjm6m4ETPGezaoTBdJCJV7RCjDRR9Ddf")
    }
    
    func mainBitcoinCashAddressGeneration() {
        let wallet = Wallet(seed: seed, network: .main(.bitcoinCash))
        
        let firstAccount = wallet.generateAccount(at: 0)
        
        print("MBCH Address: ", firstAccount.address)
        print("MBCH Public Key: ", firstAccount.rawPublicKey)
        print("MBCH Private Key: ", firstAccount.rawPrivateKey)
    }
    
  /*  func testLitecoinAddressFromPrivateKeyGeneration() {
        let privateKey = PrivateKey(pk: "T3d12aqL7XSNqMojMtqBZGhQ6E93dzrdbnNUKMvdmVTa9TQn4L3m", coin: .litecoin)
        XCTAssertEqual(privateKey.publicKey.address, "LV8fThzQw45HT6bCgs1yfvLNzv4aFvjJt1")
    }
    
    func testBitcoinCashAddressFromPrivateKeyGeneration() {
        let privateKey = PrivateKey(pk: "KwgDcj2ZDN5vzRXsTv1F6vzQV7nx7shEYjFBcWng1sH6Fy9rhK2b", coin: .bitcoinCash)
        XCTAssertEqual(privateKey.publicKey.address, "1FYh9oXWbAzgcX3hPSrRWUodYWt87bMmne")
    }*/*/
}

